User Tools

Site Tools


bash:output:check_exit_status

Differences

This shows you the differences between two versions of the page.

Link to this comparison view

Next revision
Previous revision
bash:output:check_exit_status [2021/01/26 14:49] – created peterbash:output:check_exit_status [2021/01/26 14:58] (current) – [Exit Status from a piped command - using PIPESTATUS] peter
Line 1: Line 1:
 ====== BASH - Output - Check Exit Status ====== ====== BASH - Output - Check Exit Status ======
 +
 +To get the exit status, you use the special parameter **$?** after running the command:
 +
 +<code bash>
 +command
 +status=$?
 +</code>
 +
 +----
 +
 +===== Check exit status =====
 +
 +If you don't actually want to store the exit status, but simply want to take an action upon success or failure, just use if:
 +
 +<code bash>
 +if command; then
 +    printf "it succeeded\n"
 +else
 +    printf "it failed\n"
 +fi
 +</code>
 +
 +----
 +
 +===== Exit Status from a piped command - use PIPESTATUS =====
 +
 +What if you want the exit status of one command from a pipeline?
 +
 +If you want the last command's status, no problem -- it's in **$?** just like before.
 +
 +If you want some other command's status, use the PIPESTATUS array.
 +
 +<WRAP info>
 +**NOTE:**  This is BASH only.
 +
 +In the case of Zsh, it's lower-cased pipestatus). 
 +
 +</WRAP>
 +
 +Say you want the exit status of grep in the following:
 +
 +<code bash>
 +grep foo somelogfile | head -5
 +status=${PIPESTATUS[0]}
 +</code>
 +
 +----
 +
 +Bash 3.0 added a **pipefail** option as well, which can be used if you simply want to take action upon failure of the grep:
 +
 +<code bash>
 +set -o pipefail
 +if ! grep foo somelogfile | head -5; then
 +    printf "uh oh\n"
 +fi
 +</code>
 +
 +----
  
bash/output/check_exit_status.1611672558.txt.gz · Last modified: 2021/01/26 14:49 by peter

Donate Powered by PHP Valid HTML5 Valid CSS Driven by DokuWiki